﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Net;
using System.Net.Sockets;

using System.Threading;

using System.IO;

namespace VBParadiseEasyTCPChat
{
    public partial class Auftragsliste : Form
    {
        public Auftragsliste()
        {
            InitializeComponent();
        }


        private TcpClient tcpClient;

        private StreamReader streamReader;
        private StreamWriter streamWriter;

        Server tcpServer = new Server("0.0.0.0", 8000);

        private void Auftragsliste_Load(object sender, EventArgs e)
        {

            this.Focus();
            this.Activate();
        }

        private void _savebttn_Click(object sender, EventArgs e)
        {
            string[] _data = new string[_chatlb.Items.Count];
            _chatlb.Items.CopyTo(_data, 0);

            File.AppendAllLines("log.txt", _data);
        }

        private void _sendbttn_Click(object sender, EventArgs e)
        {
            streamWriter.WriteLine(_outputtb.Text);
            streamWriter.Flush();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            tcpServer.Start();
            button1.Enabled = false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            tcpClient = new TcpClient("192.168.0.215", 8000);

            _chatlb.Enabled = _savebttn.Enabled = _outputtb.Enabled = _sendbttn.Enabled = true;

            streamReader = new StreamReader(tcpClient.GetStream());
            streamWriter = new StreamWriter(tcpClient.GetStream());

            new Thread(new ThreadStart(() =>
            {
                streamWriter.WriteLine("user=" + Environment.UserName);
                streamWriter.Flush();
                while (tcpClient.Connected)
                {
                    string _message = streamReader.ReadLine();
                    this.InvokeI(() =>
                    {
                        _chatlb.Items.Add(_message);
                    });
                }
            })).Start();

            button2.Enabled = false;
        }

        private void Auftragsliste_FormClosing(object sender, FormClosingEventArgs e)
        {
            Environment.Exit(Environment.ExitCode);
        }

  

    }

    public static class Extension
    {
        public static void InvokeI(this Form _frm, Action _delegate)
        {
            _frm.Invoke(_delegate);
        }
    }
}
